﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Models.Game
{
    public class Game
    {
        public Player CurrentPlayer { get; set; }

        private Map UsedMap { get; set; }

        private De Dice1 {  get; set; }
        private De Dice2 {  get; set; }

        private int Turn { get; set; }

        private Rules.Rules Rules { get; set; }


        public Game(Player player,Map map)
        {
            UsedMap = map;
            CurrentPlayer = player;
            Dice1 = new De();
            Dice2 = new De(1);
            Turn = 0;
            Rules = new Rules.Rules();
        }

        public void ThrowDice()
        {
            Dice1.Lancer();
            Dice2.Lancer();
        }

        public int ResultOperation(Operation o)
        {
            switch (o)
            {
                case Operation.LOWER:
                    return Dice1.IsLower(Dice2) ? Dice1.Nb : Dice2.Nb;

                case Operation.HIGHER:
                    return Dice1.IsLower(Dice2) ? Dice2.Nb : Dice1.Nb;

                case Operation.SUBTRACTION:
                    return Dice1.IsLower(Dice2) ? Dice2.Nb - Dice1.Nb : Dice1.Nb - Dice2.Nb;

                case Operation.ADDITION:
                    return Dice2.Nb + Dice1.Nb;

                case Operation.MULTIPLICATION:
                    return Dice2.Nb * Dice1.Nb;
                default:
                    return 0;
            }
        }

        public void PlaceResult (Cell playerChoice,int result)
        {
            if (Turn == 1) 
            {
                playerChoice.Value = result;
            }
            else
            {
                if(Rules.NearCell(playerChoice,UsedMap.Cells))
                {
                    playerChoice.Value = result;
                }
            }
        }

        public void AddRopeZone(Cell playerChoice,RopesZones list)
        {
        }

    }
}
